#!/usr/bin/perl -w

use strict;

my $pdb=$ARGV[0];
my $chainID=$ARGV[1];
my $separation=$ARGV[2];

my $mapScript="~/scripts/compute_DT_map.pl";
my @map=`$mapScript $pdb $chainID $separation`;
chomp @map;

my @res=&extractChain($pdb,$chainID);
my $numRes=@res;

my @residues;
for(my $i=0;$i<$numRes;$i++) {
	$residues[$i]=0;
}

foreach(@map) {
	my @v=split(/,/);
	if($v[2]==1) {
		my $index=$v[0]-1;
		$residues[$index]++;
	}
}

foreach(@residues) {
	print "$_\n";
}


sub extractChain {
        my $pdb=shift @_;
        my $chainID=shift @_;

        my @atoms;

        my @lines=`cat $pdb`;
        chomp @lines;
        $chainID=" " if(not defined $chainID);
        $chainID=" " if($chainID eq "_");

        my $lastResidue;
        foreach my $line (@lines) {
                if($line=~/^ATOM/) {
                        my $resName=substr($line,17,3);
                        my $atomName=substr($line,12,4);
                        $atomName=~s/ //g;
                        my $cID=substr($line,21,1);
                        my $residueID=substr($line,22,5);
                        if((($resName ne "GLY" and $atomName eq "CB") or ($resName eq "GLY" and $atomName eq "CA")) and $cID eq $chainID) {
                                next if(defined $lastResidue and $residueID eq $lastResidue);
                                $lastResidue=$residueID;
                                push @atoms,$line;
                        }
                }
                last if($line=~/^ENDMDL/);
        }

        return @atoms;
}
	
