#!/usr/bin/perl -w

use strict;

my $pdb=$ARGV[0];
my $chainID=$ARGV[1];
undef $chainID if(defined $chainID and $chainID eq "_");

my $inHeader=1;
my $inChain=0;
open(FH,"dsspcmbi $pdb 2>/dev/null|") or die "Can't open $pdb";
while(<FH>) {
	chomp;
	if($inHeader) {
		if(/RESIDUE AA STRUCTURE/) {
			$inHeader=0;
		}
	} else {
		my $resID=substr($_,11,1);
		my $aaTYPE=&filterAA(substr($_,13,1));
		last if($aaTYPE eq "!" and $inChain==1);
		if(not defined $chainID or $resID eq $chainID) {
			next if($aaTYPE eq "X" or $aaTYPE eq "!");

			$inChain=1;
			my $sa=&filterSA(substr($_,35,3),$aaTYPE);

			print "$aaTYPE,$sa\n";
		}
	}
}

close FH;

sub filterAA {
	my $origCode=shift @_;

	$origCode="C" if($origCode=~/^[a-z]$/);
	return $origCode;
}

sub filterSA {
	my $Acc=shift @_;
	my $aaTYPE=shift @_;

	$Acc/=106 if($aaTYPE eq "A");
	$Acc/=160 if($aaTYPE eq "B");
	$Acc/=135 if($aaTYPE eq "C");
	$Acc/=163 if($aaTYPE eq "D");
	$Acc/=194 if($aaTYPE eq "E");
	$Acc/=197 if($aaTYPE eq "F");
	$Acc/=84 if($aaTYPE eq "G");
	$Acc/=184 if($aaTYPE eq "H");
	$Acc/=169 if($aaTYPE eq "I");
	$Acc/=205 if($aaTYPE eq "K");
	$Acc/=164 if($aaTYPE eq "L");
	$Acc/=188 if($aaTYPE eq "M");
	$Acc/=157 if($aaTYPE eq "N");
	$Acc/=136 if($aaTYPE eq "P");
	$Acc/=198 if($aaTYPE eq "Q");
	$Acc/=248 if($aaTYPE eq "R");
	$Acc/=130 if($aaTYPE eq "S");
	$Acc/=142 if($aaTYPE eq "T");
	$Acc/=142 if($aaTYPE eq "V");
	$Acc/=227 if($aaTYPE eq "W");
	$Acc/=180 if($aaTYPE eq "X");
	$Acc/=222 if($aaTYPE eq "Y");
	$Acc/=196 if($aaTYPE eq "Z");

	return $Acc;
}
